#ifndef _WWTERM_TYPES_H_
#define _WWTERM_TYPES_H_

#include <sys/text.h>

#ifdef _WONX_
#include "wonx/wonx.h"
#endif

/* ǥեȤ̿® */
#define DEFAULT_COM_SPEED COMM_SPEED_9600

/*  XON/XOFF ΥեԤ */
/* #define FLOW_CONTROL */

/* ʸɽ XON/XOFF Υեˤꡤߤ */
#define COM_PAUSE_IN_PRINTING

/* ХåեäѤΤȤϥեå夹 */
#define FLUSH_IN_BUFFER_OVER

/* Хåե(ޤ礭ʤ褦դ뤳) */
#define BUFFER_SIZE 1024

/* ǽɽʸ */
#define FIRST_STRING "WWTerm(C)2000 SAKAI Hiroaki.\nPush S at left-below of the\nvirtual keyboard to change\nthe serial port speed.\nPush C at left-below of the\nvirtual keyboard to connect\nthe serial port.\n"

/* ߥʥΥ꡼󥵥 */
#define WIDTH  (TEXT_SCREEN_WIDTH)
#define HEIGHT (TEXT_SCREEN_HEIGHT - 6)

/* ܡɤɽ */
#define KEYBOARD_X 0
#define KEYBOARD_Y (HEIGHT + 1)

/* ܡɤΥ⡼ɿ */
#define KEYBOARD_MODE_NUM 3

/* ܡɤΥ */
#define KEYBOARD_WIDTH 28
#define KEYBOARD_HEIGHT 3

#define KEYINFO_WIDTH  28
#define KEYINFO_HEIGHT  2

/* XON, XOFF */
#define XON  0x11
#define XOFF 0x13

/* ԥ */
#define NEWLINE_CODE '\n'

/* ʸ */
#define ESCAPE_CODE 0x1b

/* νѥե̾ */
#ifdef _WONX_
#define LOG_FILE "log%d"
#else
#define LOG_FILE "/ram0/log%d"
#endif

#ifdef _WONX_ /* WonX */
#define wonx_lcddraw_level_down() wonx_lcddraw_level_down()
#define wonx_lcddraw_level_up()   wonx_lcddraw_level_up()
#else
#define wonx_lcddraw_level_down() do { /* None */ } while (0)
#define wonx_lcddraw_level_up()   do { /* None */ } while (0)
#endif

#endif /* _WWTERM_TYPES_H_ */

/* End of Program  */
